/* ============================ */
/*        Manuel Gallegos       */
/*            cases.c           */
/*           Fall 1995          */
/* ============================ */

#include "checkin.h"


int geterror (CASES *tests)
    {
      if (! lastcase(tests))
	return tests->curr->caseptr->ERROR;
      else
	return -1;
    }
    /* returns the error for the current case
     * takes the instance tests of the class CASES
     */

int gettag (CASES *tests)
    {
      if (! lastcase(tests))
	return tests->curr->caseptr->tagged;
      else
	return -1;
    }
    /* returns 1 if the current instance is tagged 
     */

char *getcmd (CASES *tests)
    {
      return tests->curr->caseptr->cmdln;
    }
    /* returns the command line for the current case
     * takes the instance tests of the class CASES
     */

int getno (CASES *tests)
    {
      if (! lastcase(tests))
	return tests->curr->caseptr->testno;
      else
	return -1;
    }
    /* returns the test number for the current case
     * takes the instance tests of the class CASES
     */

char *getdesc (CASES *tests)
    {
      return tests->curr->caseptr->desc;
    }
    /* returns the description for the current case
     * takes the instance tests of the class CASES
     */

int gettime (CASES *tests)
    {
      if (! lastcase(tests))
	return tests->curr->caseptr->timeout;
      else
	return -1;
    }
    /* returns the time limit for the current case
     * takes the instance tests of the class CASES
     */

char *getdiff (CASES *tests)
    {
      return tests->curr->caseptr->diffopt;
    }
    /* returns the diff options for the current case
     * takes the instance tests of the class CASES
     */

char *getoutf (CASES *tests)
    {
      OUTF *outfname;
      char *tempfname;

      tempfname = (char *) malloc (sizeof(char) * 200);

      outfname = tests->curr->caseptr->output;
      while ( outfname != NULL)
	{
	  tempfname = strcat (tempfname,outfname->fname);
	  tempfname = strcat (tempfname," \0");
	  outfname = outfname->nextout;
	}

      return tempfname;
    }
    /* takes the instance tests of the class CASES and returns a string
     * which is the list of output files in OUTF
     */

void nextcase (CASES *tests)
    {
      if (! lastcase(tests) )
	{
	  tests->curr = tests->curr->next;
	}
    }
    /* takes the instance tests of the class CASES
     * moves to the next case 
     */

void firstcase (CASES *tests)
    {
      tests->curr = tests->head;
    }
    /* takes the instance tests of the class CASES
     * moves to the first case listed in the instance
     */

int lastcase (CASES *tests)
    {
      if ( tests->curr == NULL ) 
	return 1;
      else
	return 0;
    }
    /* returns 1 if at last instance of CASES, 0 otherwise
     * takes the instances tests of the class CASES
     */

CASES *createlist ( )
    {
      CASES *tests;

      tests = (CASES *) malloc (sizeof(CASES));
      tests->head = (TEST *) malloc (sizeof(TEST));
      tests->head = NULL;
      tests->curr = tests->head;
      tests->tail = tests->head;
      tests->amount = 0;

      return tests;
    }
    /* returns an instance of CASES
     * creates an instance of CASES 
     */


void newcase (CASES *tests, int newtno)
    {
      TEST *newtest;

      newtest = (TEST *) malloc (sizeof(TEST));
      newtest->caseptr = (CASE *) malloc (sizeof(CASE));
      newtest->next = (TEST *) malloc (sizeof(TEST));
      newtest->next = NULL;
      newtest->caseptr->cmdln = (char *) malloc (sizeof(char) * 90);
      newtest->caseptr->desc = (char *) malloc (sizeof(char) * 90);
      newtest->caseptr->diffopt = (char *) malloc (sizeof(char) * 90);
      newtest->caseptr->output = (OUTF *) malloc (sizeof(OUTF));
      newtest->caseptr->output = NULL;
      newtest->caseptr->ERROR = 0;
      newtest->caseptr->testno = newtno;
      newtest->caseptr->timeout = 0;
      newtest->caseptr->tagged = 0;

      tests->tail = (TEST *) malloc (sizeof(TEST));
      tests->tail = newtest;
      if (tests->amount == 0)
	{
	  tests->head = newtest;
	  tests->curr = newtest;
	}
      else
	{
	  firstcase (tests);
	  while (tests->curr->next != NULL)
	    {
	      tests->curr = tests->curr->next;
	    }
	  tests->curr->next = newtest;
	  tests->curr = tests->curr->next;
	}
      tests->amount++;
    }
    /* takes the instance tests of the class CASES
     * creates a new case for the object tests
     */

void setcmd (CASES *tests, char *cmd)
    {
      tests->curr->caseptr->cmdln = strcpy (tests->curr->caseptr->cmdln, cmd);
    }
    /* takes the instance tests of the class CASES and the command line
     * places cmd into the current instance of CASES
     */

void settno (CASES *tests, int tno)
    {
      tests->curr->caseptr->testno = tno;
    }
    /* takes the instance tests of the class CASES and the test number
     * places tno into the current instance of CASES
     */

void settag (CASES *tests)
    {
      tests->curr->caseptr->tagged = 1;
    }
    /* takes the instance tests of the class CASES and
     * "tags" it
     */

void setdesc (CASES *tests, char *desc)
    {
      tests->curr->caseptr->desc = strcpy (tests->curr->caseptr->desc, desc);
    }
    /* takes the instance tests of the class CASES and the description
     * places desc into the current instance of CASES
     */

void settime (CASES *tests, int time)
    {
      tests->curr->caseptr->timeout = time;
    }
    /* takes the instance tests of the class CASES and the time limit
     * places time into the current instance of CASES
     */

void setdiff (CASES *tests, char *dopt)
    {
      tests->curr->caseptr->diffopt=strcpy(tests->curr->caseptr->diffopt,dopt);
    }
    /* takes the instance tests of the class CASES and the diff options
     * places dopt into the current instance of CASES
     */

void setoutf (CASES *tests, char *outfiles)
    {
      OUTF *outfname;
      char *tempfname;

      tempfname = (char *) malloc (sizeof(char) * 30);
      outfname = (OUTF *) malloc (sizeof(OUTF));

      debug_msg ("setting output files");
      if ( strlen(outfiles) == 0 )
	return;
      tests->curr->caseptr->output = outfname;
      tempfname = strtok(outfiles," \n\0");
      if (tempfname == NULL)
	return;
      debug_msg(tempfname);
      strcpy(outfname->fname,tempfname);
      while ( (tempfname = strtok(NULL," \n\0")) != NULL)
	{
	  debug_msg (tempfname);
	  outfname->nextout = (OUTF *) malloc (sizeof(OUTF));
	  outfname = outfname->nextout;
	  strcpy(outfname->fname,tempfname);
	}
      debug_msg("done setting");
      outfname->nextout = (OUTF *) malloc (sizeof(OUTF));
      outfname->nextout = NULL;
    }
    /* takes the instance tests of the class CASES and the list of outfiles
     * places outfiles into the current instance of CASES through OUTF
     */

void addoutf (CASES *tests, char *outfile)
    {
      OUTF *outfname;
      OUTF *currout;

      debug_msg ("adding output file");
      if ( strlen(outfile) == 0 )
	return;
      outfname = (OUTF *) malloc (sizeof(OUTF));
      strcpy(outfname->fname,outfile);
      debug_msg (outfname->fname);
      outfname->nextout = (OUTF *) malloc (sizeof(OUTF));
      outfname->nextout = NULL;
      currout = tests->curr->caseptr->output;
      if (currout != NULL)
	{
	  while (currout->nextout != NULL)
	    {
	      currout = currout->nextout;
	    }
	  currout->nextout = outfname;
	}
      else
	{
	  tests->curr->caseptr->output = outfname;
	}
      debug_msg("done adding");
    }
    /* takes the instance tests of the class CASES and the list of outfiles
     * places outfiles into the current instance of CASES through OUTF
     */

void seterror (CASES *tests, int error)
    {
      tests->curr->caseptr->ERROR = error;
    }
    /* takes the instance tests of the class CASES and the error
     * places error into the current instance of CASES
     */

void listcases (CASES *tests)
    {
      firstcase (tests);
      while (! lastcase(tests) )
	{
	  printf ("%d %d <%s> <%s>\n",getno(tests),geterror(tests),getcmd(tests),getdesc(tests));
	  nextcase (tests);
	}
    }
    /* takes the class CASES and lists every instance
     */

void gotolast (CASES *tests)
    {
      tests->curr = tests->tail;
    }
    /* places the current pointer at the last instance
     * in the class of CASES
     */



void debug_msg (char *msg)
{
  if (DEBUG)
    fprintf (stderr, "%s\n",msg);
}
