/* ============================ */
/*        Manuel Gallegos       */
/*           fileopt.c          */
/*           Fall 1995          */
/* ============================ */

#include "checkin.h"

#define MODE 0700               /* u:rwx, g:---, o:--- */


/* checks to see if CDIR exists and creates it if it does not
 * if CDIR was just created, CMDF header outputed
 * returns 1 if just created, 0 otherwise
 */

int CDIR_made ( void )
     {
       int pid, written;
       char *dmsg;
       FILE *cmdptr;

       dmsg = (char *) malloc (sizeof(char)*80);

       if ( (pid = file_exist(CDIR)) != 3 )
	 {
	   debug_msg ("directory does not exist, creating it");
	   sprintf (dmsg,"file_exist returned %d",pid);
	   debug_msg (dmsg);
	   mkdir(CDIR,MODE);
	   written = output_header ();
	   return written;
	 }
       else
	 {
	   debug_msg ("directory exists ... checking for file");
	   if ( (cmdptr = fopen(CMDF,"r")) == NULL )
	     {
	       debug_msg ("no command file");
	       fclose(cmdptr);
	       written = output_header ();
	       return written;
	     }
	   else
	     {
	       fclose(cmdptr);
	       debug_msg ("command file exists");
	       return 0;
	     }
	 }
     }


/* outputs global headers to CMDF
 * returns 1 if successful, else exists with NOWRITE
 */

int output_header ( void )
     {
       FILE *cmdptr;

       debug_msg ("outputting global headers");
       if ( (cmdptr = fopen(CMDF,"w+")) == NULL )
	 {
	   fprintf (stderr,"Error opening %s for output.\n",CMDF);
	   exit (NOWRITE);
	 }
       debug_msg ("file open to write to");
       fprintf(cmdptr,"global_timeout=%d\n",gtime);
       fprintf(cmdptr,"global_diff_options=%s\n",gdiff);
       fprintf(cmdptr,"# ************************************\n\n");
       fclose(cmdptr);
       debug_msg ("done outputting");

       return 1;
     }


/* places current instance of CASES into CMDF
 */

void update_CMDF ( CASES *tests, FILE *cmdptr )
    {
      fprintf(cmdptr,"%d\n",getno(tests));
      fprintf(cmdptr,"\tcommand=%s\n",getcmd(tests));
      fprintf(cmdptr,"\tdescription=%s\n",getdesc(tests));
      fprintf(cmdptr,"\ttimeout=%d\n",gettime(tests));
      fprintf(cmdptr,"\tdiff_options=%s\n",getdiff(tests));
      fprintf(cmdptr,"\toutput_files=%s\n",getoutf(tests));
      fprintf(cmdptr,"\n");
    }


/* opens CMDF for appending
 */

FILE *append_CMDF ( void )
    {
      FILE *cmdptr;

      debug_msg ("opening command file for appending");
      if ( (cmdptr = fopen(CMDF,"a+")) == NULL )
	{
	  fprintf (stderr,"Error opening %s for output.\n",CMDF);
	  exit (NOWRITE);
	}
      debug_msg ("file open to write to");

      return cmdptr;
    }

