/* Jonathan J. Raloff */
/* makel.c            */
/* This file takes argv and argc and returns the parsed list */


#include "checkin.h"

INTLIST *numlist(int argc, char *argv[]);

void usage(char *s)
{
printf("Usage: %s [-h|--help] [-f] [<nnn,nnn-nnn>]\n",s);
	  printf("\t -h|--help displays this message\n"
		 "\t -f lists failed cases\n"
		 "\t <nnn,nnn-nnn> lists tests specified in ranges\n");
}

CASES *makel(int argc, char *argv[])
{
  INTLIST *ilist;
  int failed=0;
  FILE *fp;
  char filename[80];
  int number;
  INTLIST *templ;
  INTLIST *temp2;
  INTLIST *flist;
  INTLIST *rlist;
  INTLIST *temp3;
  char *tempstr;

  tempstr = (char *) malloc (sizeof(char) * 500);

  debug_msg ("making list");
  tests=createlist();
  debug_msg ("parsing file now");
  if(!parse_cfile())
    {
      printf("Couldn't open %s.\n",CMDF);
      exit(-1);
    }
  
  debug_msg ("done parsing the file");
  if (argc==1)               /* no opts tags all */
    for(firstcase(tests);!lastcase(tests);nextcase(tests))
      settag(tests);
  else
    {
      if (DEBUG)
	printf ("%d\n",argc);
      if (!strcmp(argv[1],"-f"))  /*checks for failed flag */
	{
	  debug_msg ("setting failed range");
	  if ( (argc > 2) && (argv[2][0] == '-') )
	    {
	      usage (argv[0]);
	      exit (-1);
	    }
	  failed=1;
	  debug_msg ("does failed file exist?");
	  if ( (fp = fopen(FAILED,"r")) == NULL)
	    {
	      debug_msg ("no failed file to read");
	      fprintf (stderr,"No failed cases recorded.\n");
	      exit (-5);
	    }
	  else
	    {
	      debug_msg ("failed file can be read");
	      fclose (fp);
	    }
	  if (argc == 2)
	    {
	      gotolast (tests);
	      sprintf (argv[1],"0-%d",getno(tests));
	      debug_msg (argv[1]);
	    }
	  else
	    {
	      argv++;
	      argc-=1;
	    }
	}
      else if ((!strcmp(argv[1],"--help"))||(!strcmp(argv[1],"-h")))  
	/* help option */
	{
	  usage(argv[0]);
	  exit(-1);
	}
      else if (argv[1][0] == '-')    /* invalid option */
	{
	  usage (argv[0]);
	  exit(-1);
	}
      argv++;
      argc-=1;
      ilist=numlist(argc,argv);
      if (failed)
	{
/*
	  sprintf(filename, "%s/failed", );
	  if (file_exist(filename)==2)
	    {
	      debug_msg ("file can be opened for reading");
	      if ( (fp=fopen(filename, "r")) == NULL )
		{
		  fprintf (stderr,"No failed cases recorded.\n");
		  exit (-5);
		}
 */
	  debug_msg ("re-opening failed file for reading");
	  if ( (fp = fopen(FAILED,"r")) == NULL )
	    {
	      fprintf (stderr,"No failed cases recorded.\n");
	      exit (-5);
	    }
#if 1
	      debug_msg ("making another list");
	      fscanf(fp,"%s\0",tempstr);
	      debug_msg (tempstr);
	      strcpy (argv[0], tempstr);
	      debug_msg ("making list");
	      flist = numlist(1,argv);
	      debug_msg ("tagging needed files");
	      rlist = (INTLIST *) NULL;
	      for(temp2=ilist;temp2!=NULL;temp2=temp2->next)
		  for(templ=flist;templ!=NULL;templ=templ->next)
		      {
			  sprintf (tempstr,"checking %d %d",temp2->testno,templ->testno);
			  debug_msg (tempstr);			  
			  if (templ->testno == temp2->testno)
			      {
				  temp3 = (INTLIST *) malloc (sizeof(INTLIST));
				  temp3->testno = templ->testno;
				  temp3->next = rlist;
				  rlist = temp3;
				  sprintf (tempstr,"matched failed #%d",temp3->testno);
				  debug_msg (tempstr);
				  break;
			      }
		      }
	      ilist = rlist;
#else
	      debug_msg ("looping through file");
	      templ=ilist;
	      temp2=templ;
	      while(!feof(fp))
		{
		  fscanf(fp,"%d",&number);
		  sprintf (tempstr,"read from file #%d",number);
		  debug_msg (tempstr);
		  while(((templ!=NULL) && (templ->testno<number)))
		      {
		    if(templ==ilist)
		      {
			ilist=ilist->next;
			templ=ilist;
			free(temp2);
			temp2=ilist;
		      }
		    else
		      {
			temp2->next=templ->next;
			free(templ);
			templ=templ->next;
		      }
		  }
		  debug_msg ("either null or need to check next val");
		  if (number==templ->testno)
		    {
			debug_msg ("vals match");
		      temp2=templ;
		      templ=templ->next;
		    }
		  debug_msg ("remove comma in file");
		  if(!feof(fp))
		    getc(fp);
		    }
#endif
#if 0
	    }
	  else 
	    {
	      fprintf(stderr, "No failed cases listed.\n");
	      exit(-1);
	    }
#endif
	}
      debug_msg ("tagging needed files");
      for(firstcase(tests);!lastcase(tests);nextcase(tests))
	for(templ=ilist;templ!=NULL;templ=templ->next)
	  if(getno(tests)==templ->testno)
	    {
	      settag(tests);
	      break;
	    }
    }
  return (tests);
}




