#include "checkin.h"
#include <ctype.h>
/* Initially created by Jon Raloff on 11/15/95 */
/* $Id$ */
/* program that takes a list on the command line and convert it to */
/* an ordered linkend list of integers */

INTLIST *l=NULL;   /* The linked list */

void add_l(int);   /* Adds number to correct position of list */

/* returnes linked list of integers from the command args */

INTLIST *numlist(int argc, char *argv[])
{
char *list;  /* Input list space */
int i,j;     /* used as temperary counters */
int testnum;  /* first number of a number or a range */
int testnum2; /* second number of a range */
char next;    /* next char in list */
char *tempstr;

/* sets up the list from the command args */
l = (INTLIST *) NULL;
list=(char *)malloc(sizeof(char));
tempstr = (char *) malloc (sizeof(char) * 15);
list[0]='\0';
sprintf (tempstr,"entering with %d",argc);
debug_msg(tempstr);
debug_msg ("making list");
for(i=0;i<argc;i++)
{  
  if (isdigit(list[strlen(list)-1])&&isdigit(argv[i][0]))
    {
      debug_msg ("not a valid sequence");
      fprintf(stderr,"Two numbers following each other without ',' or '-'\n");
      exit(-1);
    }
  list=strcat(list,argv[i]);
  debug_msg ("number added to list");
}
debug_msg ("is list end with number?");
if (!isdigit(list[strlen(list)-1]))
{
  debug_msg ("ends with a non-number");
  fprintf(stderr, "List does not end with a number\n");
  exit(-1);
}

debug_msg ("going through list making strings to numbers");
i=0;
while(strlen(list)>0)
  {                      
    sscanf(list,"%d",&testnum);             /* GETS A NUMBER */
    list+=strspn(list,"1234567890");

    debug_msg ("checking validity of \"number\"");
    if(testnum>=0)                         /* if it has a good number */
      {
	next='\0';                         /* gets next char    */
        sscanf(list,"%c",&next);          
	list++;
	if((next==',') || (next=='\0'))    /* handles commas   */
	  add_l(testnum);                  /* adds that number */
	else if (next=='-')                /* handles a list */
	  {
	    sscanf(list,"%d",&testnum2);      /* gets the end of the range */
	    list+=strspn(list,"1234567890");
	    if (testnum>testnum2)              /* checks for valid range */
	      {
		fprintf(stderr, "Bad Range %d-%d\n",testnum,testnum2);
		exit(-1);
	      }
	    for(i=testnum;i<=testnum2;i++)    /* adds all numbers in range */
	      add_l(i);
	    next='\0';
	    sscanf(list,"%c",&next);          /* lookes for the comma */
	    list++;
	    if ((next!='\0')&&(next!=','))
	      {
		fprintf(stderr, "Bad list expecting ',' or end of string got '%c'\n",next);
		exit(-1);
	      }
	  }
	else     /* not a valid list */
	  {
	    fprintf(stderr, "Bad list expecting ',' or '-' got '%c'\n",next);
	    exit(-1);
	  }
      }
    else    /* bad number <0 */
      {
	fprintf(stderr, "Bad number %d \n",testnum);
	exit(-1);
      }
  }
  debug_msg ("done with list creation");

return l;
}

/* adds number to proper location in the list */

void add_l(int num)
{
  INTLIST *tmp;
  INTLIST *new;
  INTLIST *pre;

  if(l==NULL)          /* creates new list */
    {
      l=(INTLIST *)malloc(sizeof(INTLIST));
      l->next=NULL;
      l->testno=num;
    }
  else                /* searches for position */
    {
      pre=NULL;
      for(tmp=l;((tmp!=NULL)&&(tmp->testno<=num));tmp=tmp->next)
	pre=tmp;
      if (pre==NULL)  /* Add to head */
	{
	  new=(INTLIST *)malloc(sizeof(INTLIST));
	  new->testno=num;
	  new->next=tmp;
	  l=new;
	}
      else if(pre->testno!=num) /* Add to middle if not repeat */
	{
	  new=(INTLIST *)malloc(sizeof(INTLIST));
	  new->testno=num;
	  new->next=tmp;
	  pre->next=new;
	}
    }
}


