%{
/* ============================ */
/*        Manuel Gallegos       */
/*           scan.lex           */
/*           Fall 1995          */
/* ============================ */

#include "checkin.h"

void getyytext ( void );

int tn;
char field[90];

%}
dig      [0-9]
letter   [A-Za-z]
wtsp     [\ \t\n\r\v\f\b]
tno      {dig}+
cmd      "command="
desc     "description="
tout     "timeout="
dopt     "diff_options="
gto      "global_timeout="
gdo      "global_diff_options="
outf     "output_files="
%%
{wtsp}     {;}
{gto}      {getyytext ();
	    gtime = atoi (yytext);}
{gdo}      {getyytext ();
	    strcpy(gdiff,yytext);}
{tno}      {tn = atoi (yytext);
	    return STNO;}
{cmd}      {getyytext ();
	    return SCMD;}
{desc}     {getyytext ();
	    return SDSC;}
{tout}     {getyytext ();
	    return STO;}
{dopt}     {getyytext ();
	    return SDO;}
{outf}     {getyytext ();
	    return SOF;}
"#"        {while ( (field[0]=input()) != '\n' );}
.          {fprintf (stderr,"%s file has incorrect format\nAborting.\n",CMDF);
	    exit (-1);}

%%
void getyytext ( )
     {
       char field[90];
       int i, j;
       
       i = 0;
       if ( (field[i]=input()) != '\n' )
	 {
	   unput(field[i]);
	   while ( (field[i]=input()) == ' ' );
	   i++;
	   while ( (field[i]=input()) != '\n' )
	     i++;
	   field[i] = '\0';
	   for (j=0;j<=i;j++)
	     yytext[j] = field[j];
	 }
       else
	 {
	   yytext[0] = '\0';
	 }
     }
