/* ============================ */
/*        Manuel Gallegos       */
/*            cases.c           */
/*           Fall 1995          */
/* ============================ */
/*        Nathan Paris          */
/*          rt 2.0              */
/*  added for timeout, diff,    */
/*       output files           */
/* ============================ */
/*         Asa Shows            */
/*  added for get outfiles,     */
/*        getdifstr             */
/* ============================ */

#include "rt.h"

char *getoutfiles (CASES *tests) /* Asa Shows */
{
    return tests->curr->caseptr->outfiles;
}
    /* returns the list of output files for the current
     * case Null if none
     */

char *getdiffstr (CASES *tests)  /* Asa Shows */
{
    return tests->curr->caseptr->diffstr;
}
    /* returns the diff string if one exists otherwise returns
     * null
     */

int geterror (CASES *tests)
    {
      return tests->curr->caseptr->ERROR;
    }
    /* returns the error for the current case
     * takes the instance tests of the class CASES
     */

char *getcmd (CASES *tests)
    {
      return tests->curr->caseptr->cmdln;
    }
    /* returns the command line for the current case
     * takes the instance tests of the class CASES
     */


int getno (CASES *tests)
    {
      return tests->curr->caseptr->testno;
    }
    /* returns the test number for the current case
     * takes the instance tests of the class CASES
     */

char *getdesc (CASES *tests)
    {
      return tests->curr->caseptr->desc;
    }
    /* returns the description for the current case
     * takes the instance tests of the class CASES
     */

void nextcase (CASES *tests)
    {
      if (! lastcase(tests) )
	{
	  tests->curr = tests->curr->next;
	}
    }
    /* takes the instance tests of the class CASES
     * moves to the next case 
     */

void firstcase (CASES *tests)
    {
	tests->curr = tests->head;
    }
    /* takes the instance tests of the class CASES
     * moves to the first case listed in the instance
     */

int lastcase (CASES *tests)
    {
      if ( tests->curr == NULL ) 
	return 1;
      else
	return 0;
    }
    /* returns 1 if at last instance of CASES, 0 otherwise
     * takes the instances tests of the class CASES
     */

CASES *createlist ( )
    {
      CASES *tests;

      tests = (CASES *) malloc (sizeof(CASES));

      return tests;
    }
    /* returns an instance of CASES
     * creates an instance of CASES 
     */

void matchtest (CASES *tests, int newtno)
    {
      if (getno(tests) == newtno)
	{
	  fprintf (stderr,"Duplicate test numbers listed in '%s' for test #%d.\n",CMDF,newtno);
	  fprintf (stderr,"Aborting testing.\n");
	  exit (DUPTEST);
	}
    }      

/**************** nparis *****************************/
void newcase (CASES *tests, int newtno)
    {
      firstcase (tests);
      if (tests->amount != 0)
	{
	  matchtest (tests, newtno);
	  while (tests->curr->next != NULL)
	    {
	      nextcase (tests);
	      matchtest (tests, newtno);
	    }
	  tests->curr->next = (struct teststruct *) malloc (sizeof(struct teststruct));
	  tests->curr = tests->curr->next;
	}
      else
	{
	  tests->curr = (struct teststruct *) malloc (sizeof(struct teststruct));
	}
      tests->curr->caseptr = (struct casestruct *) malloc (sizeof(struct casestruct));
      tests->curr->next = (struct teststruct *) malloc (sizeof(struct teststruct));

      tests->curr->caseptr->timeout = -1; 
      tests->curr->caseptr->outfiles=NULL;
      tests->curr->caseptr->diffstr=NULL;
      tests->curr->next = NULL;
      tests->curr->caseptr->ERROR = 0;
      tests->curr->caseptr->testno = 0;
      if (tests->amount == 0)
	{
	  tests->head = tests->curr;
	}
      tests->amount++;
    }
    /* takes the instance tests of the class CASES
     * creates a new case for the object tests
     */

void setcmd (CASES *tests, char *cmd)
    {
      tests->curr->caseptr->cmdln = strdup(cmd);
    }
    /* takes the instance tests of the class CASES and the command line
     * places cmd into the current instance of CASES
     */

void setdiff (CASES *tests, char *diff)
    {
      if (diff==NULL || *diff=='\0') {
	tests->curr->caseptr->diffstr = NULL;
      }
      else {
	tests->curr->caseptr->diffstr = strdup(diff);
      }
    }
        /* takes the instance tests of the class CASES and the command line
     * places cmd into the current instance of CASES
     */

void setoutf (CASES *tests, char *files)
    {
      if (files==NULL || *files=='\0') {
	tests->curr->caseptr->outfiles = NULL;
      }
      else {
	tests->curr->caseptr->outfiles = strdup(files);
      }
    }
        /* takes the instance tests of the class CASES and the command line
     * places cmd into the current instance of CASES
     */

void settimeout (CASES *tests, int to)
    {
      tests->curr->caseptr->timeout = to;
    }
        /* takes the instance tests of the class CASES and the command line
     * places cmd into the current instance of CASES
     */
void settno (CASES *tests, int tno)
    {
      tests->curr->caseptr->testno = tno;
    }
    /* takes the instance tests of the class CASES and the test number
     * places tno into the current instance of CASES
     */

void setdesc (CASES *tests, char *desc)
    {
      tests->curr->caseptr->desc = strdup(desc);
    }
    /* takes the instance tests of the class CASES and the description
     * places desc into the current instance of CASES
     */

void seterror (CASES *tests, int error)
    {
      tests->curr->caseptr->ERROR = error;
    }
    /* takes the instance tests of the class CASES and the error
     * places error into the current instance of CASES
     */


/*************************** nparis *************************/
