/* ============================ */
/*        Manuel Gallegos       */
/*            pcfile.c          */
/*           Fall 1995          */
/* ============================ */
/*       Nathan Paris           */
/*          rt2.0               */
/* ============================ */

#include "rt.h"

FILE *fptr;
extern int ALLTESTS;
extern int GlobalTimeout;
extern char *GlobalDiff;
extern CASES *tests;

int check_left_overs(struct listtest *head);

void parse_cfile (struct listtest *head)
{
    int i, tylv, POK;  
    struct listtest *ptr; /* nparis */
    
    if ( (fptr = freopen(CMDF,"r",stdin)) == NULL )
      {
	fprintf (stderr,"Cannot access '%s'.\nAborting testing.\n",CMDF);
	exit (MISSCMD);
      }

      tests = createlist();
      tests->head = (struct teststruct *) malloc(sizeof(struct teststruct ));  /* nparis */
  
    i = 1;
    POK = 1;
    while (i != 0)
      {
	i = yylex();
	switch (i) {
	case 1: 
	  if (ALLTESTS)
	    POK = 1;
	  else
	  if (found(atoi(yytext),head))  /* nparis */
	  { /* if in subset */
	    rm_tst(atoi(yytext),head);  /* nparis */
	    POK = 1;                    /* nparis */
	  }
	  else
	    POK = 0;
	  if (POK)
	    {
	      newcase (tests, atoi(yytext));  
	      settno (tests, atoi(yytext));
	      setoutf (tests, NULL);
	      setdiff (tests, NULL);
	    }
	  break;
	case 2:
	  if (POK)
	    setcmd (tests, yytext);
	  break;
        case 3:
	  if (POK)
	    setdesc (tests, yytext); 
	  break;
        case 4:
	  if (POK)
	    GlobalTimeout = atoi(yytext);  /* nparis */
	  break;
        case 5:
	  if (POK) 
	  {
	    GlobalDiff = yytext;
	  }
	  break;
        case 6:
	  if (POK)
	    setoutf(tests, yytext);  /* nparis */
	  break;
        case 7:
	  if (POK)
	    setdiff(tests, yytext);  /* nparis */
	  break;
        case 8:
	  if (POK)
	   settimeout(tests,atoi( yytext));  /* nparis */
	  break;
	  default:
	  break;
	  } 
      }
    
    if (tests->amount == 0)
      {
	fprintf (stderr,"Unable to find desired test(s).\nAborting testing.\n");
	exit (NOTEST);
      }
    else
    if(head != NULL)
     check_left_overs(head);  /* nparis */
}


/****************************************************
 * Function: check_left_overs,   nparis
 * Purpose: checks to see if any tests were requested
 *          that arent listed in the commands file.
 *          If any tests are left on the testlist head
 *          then not in command file.
 ****************************************************/
int check_left_overs(struct listtest *head)  
{
  struct listtest *ptr;
  
   if( (ptr = head->next) != NULL)
    {
      fprintf(stderr,"Test #%d ", ptr->tstnum);
      ptr = ptr->next;
	
      while(ptr != NULL)
      {
	fprintf(stderr,"#%d ", ptr->tstnum);
        ptr = ptr->next;
      }
       fprintf(stderr,"are not in the RTtests/commands file \n");
      return(1);
    }
  return(0);
}
